package testrequest

import (
	"bytes"
	"net/http/httptest"

	"github.com/gin-gonic/gin"
)

func MakePostRequest(json *[]byte, target string, authHeader string, router *gin.Engine) string {
	body := bytes.NewBuffer(*json)
	request := httptest.NewRequest("POST", target, body)
	request.Header.Set("Authorization", authHeader)
	recorder := httptest.NewRecorder()
	router.ServeHTTP(recorder, request)
	return recorder.Result().Status
}

func MakeGetRequest(target string, router *gin.Engine) []byte {
	request := httptest.NewRequest("GET", target, nil)
	recorder := httptest.NewRecorder()
	router.ServeHTTP(recorder, request)
	return recorder.Body.Bytes()
}

func MakePutRequest(json *[]byte, target string, authHeader string, router *gin.Engine) string {
	body := bytes.NewBuffer(*json)
	request := httptest.NewRequest("PUT", target, body)
	request.Header.Set("Authorization", authHeader)
	recorder := httptest.NewRecorder()
	router.ServeHTTP(recorder, request)
	return recorder.Result().Status
}

func MakeDeleteRequest(target string, authHeader string, router *gin.Engine) string {
	request := httptest.NewRequest("DELETE", target, nil)
	request.Header.Set("Authorization", authHeader)
	recorder := httptest.NewRecorder()
	router.ServeHTTP(recorder, request)
	return recorder.Result().Status
}
